/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.jaxbexample;

import java.io.StringReader;
import java.io.StringWriter;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author omozegieaziegbe
 */
public class JAXBExample {

    public static void main(String[] args) throws JAXBException {
        // Create Authors object
        Authors authors = new Authors("Gullivers Travels", "Jonathan Swift");

        // Marshalling: Convert Java object to XML
        JAXBContext context = JAXBContext.newInstance(Authors.class);
        Marshaller marshaller = context.createMarshaller();
        StringWriter writer = new StringWriter();
        marshaller.marshal(authors, writer);
        String xmlString = writer.toString();
        System.out.println("Marshalled XML:");
        System.out.println(xmlString);

        // Unmarshalling: Convert XML to Java object
        String xmlInput = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n" +
                "<authors><title>Oliver Twist</title><author>Charles Dickens</author></authors>";
        Unmarshaller unmarshaller = context.createUnmarshaller();
        Authors unmarshalledBook = (Authors) unmarshaller.unmarshal(new StringReader(xmlInput));

        System.out.println("\nUnmarshalled Authors:");
        System.out.println("Title: " + unmarshalledBook.getTitle());
        System.out.println("Author: " + unmarshalledBook.getAuthor());
    }
}

