/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.omosmicrosystems.jaxpdomparserexample;

import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 *
 * @author omozegieaziegbe
 */
public class JAXPDOMParserExample {

    public static void main(String[] args) {
         try {
            // Create a DocumentBuilderFactory instance
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

            // Create a DocumentBuilder
            DocumentBuilder builder = factory.newDocumentBuilder();

            // Parse the XML document
            Document document = builder.parse(new File("authors.xml"));

            // Get the root element
            Element root = document.getDocumentElement();

            // Get a list of all book elements
            NodeList bookList = root.getElementsByTagName("book");

            // Loop through the book elements
            for (int i = 0; i < bookList.getLength(); i++) {
                Element book = (Element) bookList.item(i);
                String title = book.getElementsByTagName("title").item(0).getTextContent();
                String author = book.getElementsByTagName("author").item(0).getTextContent();
                System.out.print("Title: " + title );
                System.out.println(", Author: " + author);
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}